const int laser_main = 1;
const int laser_top = 2;
const int laser_middle = 3;
const int laser_bottom = 4;
const int laser_speed = 5;
const int camera = 8;
const int detector_main = A0;
const int detector_top = A1;
const int detector_middle = A2;
const int detector_bottom = A3;
const int detector_speed = A4;
static unsigned long laser_speed_on;
float distance = 513;
int signal_main;
int signal_top;
int signal_middle;
int signal_bottom;
int signal_speed;
int counter;
int state;
float speed;
float times;
int last_state;


void setup() { 
Serial.begin(9600);
pinMode(laser_main,OUTPUT);
pinMode(laser_top,OUTPUT);
pinMode(laser_middle,OUTPUT);
pinMode(laser_bottom,OUTPUT);
pinMode(laser_speed,OUTPUT);
pinMode(A0,INPUT);
pinMode(A1,INPUT);
pinMode(A2,INPUT);
pinMode(A3,INPUT);
pinMode(camera,OUTPUT);
digitalWrite(camera,HIGH);
Serial.println("CLEARDATA");
Serial.println("LABEL,Time,Type Animal, Velocity");
Serial.println("RESETTIMER");
}

void loop(){
digitalWrite(laser_main,HIGH);
signal_main = analogRead(detector_main);
state = map(signal_main,0,800,0,1);
//Serial.println(counter);
if(state != last_state){
  if(state == 1){
    counter ++;
    delay(200);
  }
  last_state = state;
}
if(counter == 1){
  //if(millis()-lasers_on > 10000){
    //lasers_on = millis(); 
    //counter = 0;
  //}
}
if(counter == 2){
  counter = 0;
}

if(counter > 3){
  counter = 3;
}

switch(counter){
  case 1:
    digitalWrite(laser_top,HIGH);
    digitalWrite(laser_middle,HIGH);
    digitalWrite(laser_bottom,HIGH);
    digitalWrite(laser_speed,HIGH);
    //delay(200);   //finetuning
    signal_top = map(analogRead(detector_top),0,800,0,1);
    signal_middle = map(analogRead(detector_middle),0,800,0,1);
    signal_bottom = map(analogRead(detector_bottom),0,800,0,1);
    //Serial.println(millis());
    if((signal_top == 1) && (signal_middle == 1) && (signal_bottom == 1)){
      //classify as big animal
        Serial.print("DATA,TIME,");
        Serial.print("Big Animal,");
        counter = 3;
      //delay(1000);
    }
    else if((signal_top == 0) && (signal_middle == 0) && (signal_bottom == 1)){
      //classify as small animal
      Serial.print("DATA,TIME,");
      Serial.print("Small Animal,");
      counter = 3;
    }
    else if((signal_top == 0) && (signal_middle == 1) && (signal_bottom == 1)){
      //take picture
      Serial.print("DATA,TIME,");
      Serial.print("Middle to determine animal,");
      digitalWrite(camera,LOW);
      counter = 3;
    }
    else if((signal_top == 1) || (signal_middle == 1) && (signal_bottom == 0)){
      //take picture
      Serial.print("DATA,TIME,");
      Serial.print("Unexpected thing detected,");
      digitalWrite(camera,LOW);
      counter = 3;
    }
    break;
  
  case 0:
    digitalWrite(laser_top,LOW);
    digitalWrite(laser_middle,LOW);
    digitalWrite(laser_bottom,LOW);
    digitalWrite(laser_speed,LOW);
    digitalWrite(camera,HIGH);
    times = 0;
    break;
  
  case 3:
    signal_speed = map(analogRead(detector_speed),0,800,0,1);
    times++;
    if(signal_speed == 1){
    //speed = distance/(millis()-laser_speed_on)*3.6;
    speed = distance/(200*times)*3.6;
    Serial.println(speed);
    counter = 0;
    }
    break;
}
delay(200);
}